package ax;

import waba.ui.MainWindow;
import waba.fx.Color;
import waba.fx.Graphics;
import waba.fx.FontMetrics;
import waba.fx.Font;

/**
 * AxLib ̃Gg|CgB
 * MainWindow ̃TuNXł邽߁A[UvOł
 * JFrame ̃TuNXCNXƂč쐬B
 */
public class JFrame extends MainWindow {

    protected String title = "";
    protected int titleHeight;

    public JFrame(String title) {
        this.title = title;
        FontMetrics metrics = getFontMetrics(AxGlobals.FONT_BOLD);
        titleHeight = metrics.getHeight() + 9;
    }

    public int getTitleHeight() {
        return titleHeight;
    }

    public void onPaint(Graphics g) {
        setColor(g, AxGlobals.COLOR_TITLE);
        g.fillRect(0, 0, width, titleHeight);

        setColor(g, AxGlobals.COLOR_BACK);
        g.fillRect(0, titleHeight, width, height);
        g.fillRect(0, 0, 1, 1);
        g.fillRect(width, 0, 1, 1);

        setColor(g, AxGlobals.COLOR_FRAME_SHADOW);

        g.drawRect(0, 0,  width, height);
        g.drawRect(1, 1,  width - 2, height - 2);
        g.drawRect(2, 2,  width - 4, height - 4);
        g.drawRect(3, 3,  width - 6, height - 6);
        g.drawRect(4, 4,  width - 8, height - 8);

        g.setFont(AxGlobals.FONT_BOLD);
        setColor(g, AxGlobals.COLOR_BLACK);
        g.drawText(title, 8, 6);
        g.drawLine( 2, 15,  2, height - 15);
        g.drawLine(15,  2, width - 15, 2);

        g.drawLine( 15, height - 3,  width - 15, height - 3);
        g.drawLine( width - 3, 15,  width - 3, height - 15);

        setColor(g, AxGlobals.COLOR_TITLE_SHADOW);
        g.drawLine( 3, 16,  3, height - 14);
        g.drawLine(16,  3, width - 14, 3);
        g.drawLine( width - 2, 16,  width - 2, height - 14);
        g.drawLine( 16, height - 2,  width - 14, height - 2);

        g.fillRect( 5, 5,  1, 1);
        g.fillRect( width - 6, 5,  1, 1);

        g.drawLine( 5, titleHeight,  width - 6, titleHeight);

        setColor(g, AxGlobals.COLOR_BACK);
        g.fillRect(0, 0, 1, 1);
        g.fillRect(width - 1, 0, 1, 1);

        super.onPaint(g);
    }

    protected static void setColor(Graphics g, Color color) {
        g.setColor(color.getRed(), color.getGreen(), color.getBlue());
    }
}
