package ax;

import waba.ui.Edit;
import waba.ui.Event;
import waba.fx.Graphics;
import waba.fx.Color;

public class JTextField extends Edit {

    public JTextField(String text) {
        super();
        setText(text);
    }

    public JTextField() {
        super();
    }

    public void onPaint(Graphics g) {
        setColor(g, AxGlobals.COLOR_WHITE);
        g.fillRect(0, 0, width, height);
        super.onPaint(g);
        drawFieldRect(g);
    }

    protected void drawFieldRect(Graphics g) {
        setColor(g, AxGlobals.COLOR_SHADOW);
        g.drawRect(0, 0, width - 1, height - 1);
        setColor(g, AxGlobals.COLOR_WHITE);
        g.drawLine(0, height - 1, width - 1, height - 1);
        g.drawLine(width - 1, 0, width - 1, height - 1);
    }

    public void onEvent(Event event) {
        super.onEvent(event);
        drawFieldRect(createGraphics());
    }

    protected static void setColor(Graphics g, Color color) {
        g.setColor(color.getRed(), color.getGreen(), color.getBlue());
    }
}
